package cowhello;

import java.io.PrintStream;
import java.util.function.BiConsumer;

/**
 * luokka, jolla saa jouhevasti komentoja kuoreen lisattya
 * @author LEEVI
 * @version 13 Apr 2023
 *
 */
public class Command {
    private String nimi;
    private BiConsumer<PrintStream,String[]> func;
    private String ohje;
    /**
     * muodostaja
     * @param nimi komennon nimi
     * @param func momento itsessään
     * @param ohje ohje komennon kayttoon
     */
    public Command(String nimi, BiConsumer<PrintStream,String[]> func,String ohje) {
        this.nimi=nimi;
        this.func=func;
        this.ohje=ohje;
    }
    
    /**
     * suorittaa komennon argumenteilla
     * @param ps tietovirta,johon komento tulostaa
     * @param args argumentit
     */
    public void exec(PrintStream ps,String[] args) {
        func.accept(ps,args);
    }
    
    public String getNimi() {return nimi;}
    public String getOhje() {return ohje;}
    protected BiConsumer<PrintStream,String[]> getfunc() {return func;}
}
