package cowhello;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.function.BiConsumer;
import java.util.function.Consumer;

/**
 * used to manage commands, ks. Command - luokka
 * sisältää muutamat valmiit komennot
 * @author LEEVI
 * @version 13 Apr 2023
 *
 */
public class Commands {
    private ArrayList<Command> komennot;
    private static Command unknownCommand = new Command("unused",(o,z) -> {o.printf("Tuntematon komento: %s%n", z[0]);},"tuntematon komento");
    
    public Commands() {
        komennot = new ArrayList<Command>();
        add("help",(o,z) -> {
            if (z.length<2) {o.printf("Kaytto : help <command>%ntunnetut komennot: "); for (Command c: komennot) o.printf("%s ",c.getNimi()); o.println();} 
            else o.println(get(z[1]).getOhje());
        },"help <komento>");
        
        String kaytto = "kaytto: alias <nimi> <komento> \nLisaa komennolle vaihtoehtoisen nimen";
        add("alias",(o,z) -> {
            if (z.length<3) {
                o.println(kaytto);
                return;
            }
            if (!hasCommand(z[2])) {o.printf("ei onnistu, komentoa %s ei ole olemassa%n", z[2]); return;}
            if (hasCommand(z[1])) {o.printf("ei onnistu, nimi %s on jo käytössä%n",z[1]); return;}
            add(z[1],get(z[2]).getfunc(),get(z[2]).getOhje());
            o.printf("lisattiin alias %s komennolle %s",z[1],z[2]);
        },kaytto);
        
    }

    public void add(Command cmd) {
        // TODO Auto-generated method stub
        if (!hasCommand(cmd)) komennot.add(cmd);
    }

    private boolean hasCommand(Command cmd) {
        // TODO Auto-generated method stub
        return komennot.contains(cmd);
    }

    public void exec(PrintStream ps, String[] arg) {
        // TODO Auto-generated method stub
        Command cmd = get(arg[0]);
        cmd.exec(ps,arg);
    }

    private Command get(String komento) {
        // TODO Auto-generated method stub
        for (Command c : komennot) {
            if (c.getNimi().equals(komento)) return c;
        }
        return unknownCommand;
    }

    public void add(String nimi, BiConsumer<PrintStream,String[]> cmd, String ohje) {
        // TODO Auto-generated method stub
        if (!hasCommand(nimi)) komennot.add(new Command(nimi,cmd,ohje));
    }

    private boolean hasCommand(String nimi) {
        // TODO Auto-generated method stub
        for (Command c : komennot) {
            if (c.getNimi().equals(nimi)) return true;
        }
        return false;
    }
    
    
}
