package cowhello;
import java.lang.Thread;
import java.io.PrintStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
/**
 * takes care of the I/O of user
 * @author LEEVI
 * @version 13 Apr 2023
 *
 */
public class ConsoleProcess extends Thread{
    private PrintStream output;
    private Scanner input;
    private Commands komennot;
    private String prompt;
    /**
     * initializes the class
     * @param in Stream that the thread will read from
     * @param out Stream that the thread will write into
     * @param prompt What gets displayed in the stream for prompt, eg "console>"
     */
    public ConsoleProcess(InputStream in, OutputStream out, String prompt) {
        this.output = new PrintStream(out);
        this.input = new Scanner(in);
        komennot = new Commands();
        this.prompt = prompt+">";
    }
    
    /**
     *  kuoren silmukka
     */
    @Override
    public void run() {
        while (true) {
            output.print(prompt);
            String syote = input.nextLine();
            if (syote.equals("")) continue;
            exec(syote);
        }
    }
 
    /**
     * tulostaa asiaa
     * @param puhuja kuka haluaa puhua
     * @param asia mita haluaa puhua
     */
    public void puhu(Object puhuja, String asia) {
        output.printf("[%s]:%s%n",puhuja.getClass().getName(),asia);
        output.flush();
    }
    
    /**
     * kysyy syotetta
     * @param  kysyja kuka kysyy
     * @param  kysymys mita kysytaan
     * @return vastaus kysymykseen
     */
    public String kysy(Object kysyja, String kysymys) {
        puhu(kysyja,kysymys);
        output.printf("[%s]>",kysyja.getClass().getName());
        return input.nextLine();
        //TODO: korjaa tama, ei toimi talla hetkella
    }
    
    /**
     * lisaa komentoja kuoreen
     * @param nimi komennon nimi
     * @param cmd  komennon funktionaalinen osa
     * @param ohje komennon ohje
     */
    public void lisaaKomento(String nimi, BiConsumer<PrintStream,String[]> cmd, String ohje) {
        komennot.add(nimi,cmd,ohje);
    }
    
    /**
     * lisaa komentoja kuoreen
     * @param cmd komento, joka lisataan
     */
    public void lisaaKomento(Command cmd) {
        komennot.add(cmd);
    }
    
    
    private void exec(String a) {
        String[] jutut = a.split(" ");
        try {
        	komennot.exec(output,jutut);
        } catch (Exception e) {
        	puhu(e,"Virhe komennon kanssa: "+e.getMessage());
        	komennot.exec(output, new String[]{"help", jutut[0] });
        }
    }
}
